=== modified file 'sql/table.cc'
--- sql/table.cc	2008-07-05 19:32:59 +0000
+++ sql/table.cc	2008-07-07 15:28:30 +0000
@@ -36,8 +36,6 @@
 			      uint types, char **names);
 static uint find_field(Field **fields, uchar *record, uint start, uint length);
 
-inline bool is_system_table_name(const char *name, uint length);
-
 /**************************************************************************
   Object_creation_ctx implementation.
 **************************************************************************/
@@ -146,17 +144,6 @@
     return TABLE_CATEGORY_INFORMATION;
   }
 
-  if ((db->length == MYSQL_SCHEMA_NAME.length) &&
-      (my_strcasecmp(system_charset_info,
-                    MYSQL_SCHEMA_NAME.str,
-                    db->str) == 0))
-  {
-    if (is_system_table_name(name->str, name->length))
-    {
-      return TABLE_CATEGORY_SYSTEM;
-    }
-  }
-
   return TABLE_CATEGORY_USER;
 }
 
@@ -344,55 +331,6 @@
   DBUG_VOID_RETURN;
 }
 
-
-/**
-  Return TRUE if a table name matches one of the system table names.
-  Currently these are:
-
-  help_category, help_keyword, help_relation, help_topic,
-  proc, event
-  time_zone, time_zone_leap_second, time_zone_name, time_zone_transition,
-  time_zone_transition_type
-
-  This function trades accuracy for speed, so may return false
-  positives. Presumably mysql.* database is for internal purposes only
-  and should not contain user tables.
-*/
-
-inline bool is_system_table_name(const char *name, uint length)
-{
-  CHARSET_INFO *ci= system_charset_info;
-
-  return (
-          /* mysql.proc table */
-          (
-           length == 4 &&
-           my_tolower(ci, name[0]) == 'p' && 
-           my_tolower(ci, name[1]) == 'r' &&
-           my_tolower(ci, name[2]) == 'o' &&
-           my_tolower(ci, name[3]) == 'c'
-          ) ||
-
-          /* one of mysql.help* tables */
-          (
-           length > 4 &&
-           my_tolower(ci, name[0]) == 'h' &&
-           my_tolower(ci, name[1]) == 'e' &&
-           my_tolower(ci, name[2]) == 'l' &&
-           my_tolower(ci, name[3]) == 'p'
-          ) ||
-
-          /* one of mysql.time_zone* tables */
-          (
-           my_tolower(ci, name[0]) == 't' &&
-           my_tolower(ci, name[1]) == 'i' &&
-           my_tolower(ci, name[2]) == 'm' &&
-           my_tolower(ci, name[3]) == 'e'
-          )
-          );
-}
-
-
 /*
   Read table definition from a binary / text based .frm file
   
@@ -517,6 +455,8 @@
     *root_ptr= old_root;
     error_given= 1;
   }
+  else
+    assert(1);
 
   share->table_category= get_table_category(& share->db, & share->table_name);
 
@@ -591,7 +531,7 @@
   if (share->frm_version == FRM_VER_TRUE_VARCHAR -1 && head[33] == 5)
     share->frm_version= FRM_VER_TRUE_VARCHAR;
 
-  legacy_db_type= (enum legacy_db_type) (uint) *(head+3);
+  legacy_db_type= DB_TYPE_FIRST_DYNAMIC;
   DBUG_ASSERT(share->db_plugin == NULL);
   /*
     if the storage engine is dynamic, no point in resolving it by its
@@ -679,14 +619,6 @@
       keyinfo->block_size= uint2korr(strpos+6);
       strpos+=8;
     }
-    else
-    {
-      keyinfo->flags=	 ((uint) strpos[0]) ^ HA_NOSAME;
-      keyinfo->key_length= (uint) uint2korr(strpos+1);
-      keyinfo->key_parts=  (uint) strpos[3];
-      keyinfo->algorithm= HA_KEY_ALG_UNDEF;
-      strpos+=4;
-    }
 
     keyinfo->key_part=	 key_part;
     keyinfo->rec_per_key= rec_per_key;

